function showModalPayTerm(action, data) {

    var id = "";
    var name = "";
    var button = "Save";

    if (action == 'edit') {
        id = data.pay_term_id;
        name = data.pay_term;
        button = "Update";
    }

    $('#settingsAddModalBody').empty();
    var content = '<div class="form-row">';
    content += '<div class="col-md-12 mb-3" id="divPayTerm">';
    content += '<label for="txtName">Pay Term</label>';
    content += '<input type="text" class="form-control" id="txtPayTerm" name="payTerm" placeholder="Pay Term" value="' + name + '" data-id="' + id + '">';
    content += '</div>';
    content += '</div>';
    $('#settingsAddModalBody').append(content);
    $('#settingsAddModalTitle').text('Pay Term');
    $('#btnDiv').empty();
    $('#btnDiv').append('<button type="button" class="btn btn-primary" id="btnPayTerm">' + button + '</button');
    $("#settingsAddModal").modal('toggle');

    $('#btnPayTerm').on('click', function () {
        var action = $(this).text();

        if (action == 'Save') {
            savePayTerm();
        } else if (action == 'Update') {
            updatePayTerm();
        }
    });


}



function showModalCurrency(action, data) {

    var id = "";
    var currency = "";
    var iso = "";
    var symbol = "";
    var button = "Save";

    if (action == 'edit') {
        id = data.currency_id;
        currency = data.currency;
        iso = data.iso_code;
        symbol = data.symbol;
        button = "Update";
    }

    $('#settingsAddModalBody').empty();
    var content = '<div class="form-row">';
    content += '<div class="col-md-12 mb-3" id="divCurrency">';
    content += '<label for="txtName">Currency</label>';
    content += '<input type="text" class="form-control" id="txtCurrency" name="currency" placeholder="Currency" value="' + currency + '" data-id="' + id + '">';
    content += '</div>';
    content += '</div>';
    content += '<div class="form-row">';
    content += '<div class="col-md-12 mb-3" id="divISO">';
    content += '<label for="txtName">ISO Code</label>';
    content += '<input type="text" class="form-control" id="txtISO" name="iso" placeholder="ISO Code" value="' + iso + '" data-id="' + id + '">';
    content += '</div>';
    content += '</div>';
    content += '<div class="form-row">';
    content += '<div class="col-md-12 mb-3" id="divSymbol">';
    content += '<label for="txtName">Symbol</label>';
    content += '<input type="text" class="form-control" id="txtSymbol" name="symbol" placeholder="Symbol" value="' + iso + '" data-id="' + id + '">';
    content += '</div>';
    content += '</div>';
    $('#settingsAddModalBody').append(content);
    $('#settingsAddModalTitle').text('Currency');
    $('#btnDiv').empty();
    $('#btnDiv').append('<button type="button" class="btn btn-primary" id="btnCurrency">' + button + '</button');
    $("#settingsAddModal").modal('toggle');

    $('#btnCurrency').on('click', function () {
        var action = $(this).text();

        if (action == 'Save') {
            saveCurrency();
        } else if (action == 'Update') {
            updateCurrency();
        }
    });


}



function savePayTerm() {
    $.ajax({
        type: "POST",
        url: '/st/erpSettingController/savePayTerm',
        data: { 'value': $('#txtPayTerm').val() },
        headers: {
            'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
        },
        timeout: 800000,
        beforeSend: function () {
            $("#settingsAddModal").modal('hide');
        },
        success: function (response) {
            console.log(response);

            if (response.data.success) {

                showSuccessMessage("Pay Terms has been saved successfully...");
                getAllPayTerm();


            } else {
                showErrorMessage();
            }

        },
        error: function (error) {
            console.log(error);
            showErrorMessage();
        },
        complete: function () {

        }

    });
}



function saveCurrency() {
    $.ajax({
        type: "POST",
        url: '/st/erpSettingController/saveCurrency',
        data: { 
            'currency': $('#txtCurrency').val(),
            'iso': $('#txtISO').val(),
            'symbol': $('#txtSymbol').val(),
        },
        headers: {
            'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
        },
        timeout: 800000,
        beforeSend: function () {
            $("#settingsAddModal").modal('hide');
        },
        success: function (response) {
            console.log(response);

            if (response.data.success) {

                showSuccessMessage("Currency has been saved successfully...");
                getAllCurrency();


            } else {
                showErrorMessage();
            }

        },
        error: function (error) {
            console.log(error);
            showErrorMessage();
        },
        complete: function () {

        }

    });
}







function getAllPayTerm() {

    $.ajax({
        type: "GET",
        url: '/st/erpSettingController/getAllPayTerm',
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                var result = response.data.result;
                appendTablePayTerm(result);

            } else {
                showErrorMessage();
            }

        },
        error: function (error) {
            console.log(error);
            showErrorMessage();
        },
        complete: function () {
            $('.ti-settings').show();
            $('.spinner-border').hide();
        }

    });
}


function getAllCurrency() {

    $.ajax({
        type: "GET",
        url: '/st/erpSettingController/getAllCurrency',
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                var result = response.data.result;
                appendTableCurrency(result);

            } else {
                showErrorMessage();
            }

        },
        error: function (error) {
            console.log(error);
            showErrorMessage();
        },
        complete: function () {
            $('.ti-settings').show();
            $('.spinner-border').hide();
        }

    });
}




function appendTablePayTerm(result) {

    var disable = { 0: "", 1: "checked" }
    var tbody = "";


    for (i = 0; i < result.length; i++) {

        var row = "<tr>";
        var str_id = "'" + result[i].pay_term_id + "'";
        row += '<td class="id" id="' + result[i].pay_term_id + '">' + generateID(result[i].pay_term_id) + '</td>';
        row += '<td>' + result[i].pay_term + '</td>';
        row += '<td class="edit edit_pay_term">';
        row += '<button type="button" class="btn btn-primary setting-edit-btn" id="' + result[i].pay_term_id + '" onclick="editPayTerm(' + str_id + ')">';
        row += '<i class="fa fa-pencil-square-o" aria-hidden="true"></button>';

        row += '</td>';
        row += '<td class="disable disable_town">';
        row += '<label class="switch">';
        row += '<input type="checkbox"  id="' + result[i].pay_term_id + '" onchange="disablePayTerm(event,' + str_id + ')" ' + disable[result[i].status] + '>';



        row += '<span class="slider round"></span>';
        row += '</label>';
        row += '</td>';
        row += '</tr>';
        tbody += row;
    }
    $('#tblPayTerm').empty();
    $('#tblPayTerm').append(tbody);




}





function appendTableCurrency(result) {

    var disable = { 0: "", 1: "checked" }
    var tbody = "";


    for (i = 0; i < result.length; i++) {

        var row = "<tr>";
        var str_id = "'" + result[i].currency_id + "'";
        row += '<td class="id" id="' + result[i].currency_id + '">' + generateID(result[i].currency_id) + '</td>';
        row += '<td>' + result[i].currency + '</td>';
        row += '<td class="edit edit_currency">';
        row += '<button type="button" class="btn btn-primary setting-edit-btn" id="' + result[i].currency_id + '" onclick="editCurrency(' + str_id + ')">';
        row += '<i class="fa fa-pencil-square-o" aria-hidden="true"></button>';

        row += '</td>';
        row += '<td class="disable disable_town">';
        row += '<label class="switch">';
        row += '<input type="checkbox"  id="' + result[i].currency_id + '" onchange="disableCurrency(event,' + str_id + ')" ' + disable[result[i].status] + '>';



        row += '<span class="slider round"></span>';
        row += '</label>';
        row += '</td>';
        row += '</tr>';
        tbody += row;
    }
    $('#tblCurrency').empty();
    $('#tblCurrency').append(tbody);




}




function editPayTerm(id) {
    $.ajax({
        type: "GET",
        url: '/st/erpSettingController/getPayTerm/' + id,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                var result = response.data.result;
                showModalPayTerm('edit', result);


            } else {
                showErrorMessage();
            }

        },
        error: function (error) {
            console.log(error);
            showErrorMessage();
        },
        complete: function () {
            $('.ti-settings').show();
            $('.spinner-border').hide();
        }

    });
}




function editCurrency(id) {
    $.ajax({
        type: "GET",
        url: '/st/erpSettingController/getCurrency/' + id,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                var result = response.data.result;
                showModalCurrency('edit', result);


            } else {
                showErrorMessage();
            }

        },
        error: function (error) {
            console.log(error);
            showErrorMessage();
        },
        complete: function () {
            $('.ti-settings').show();
            $('.spinner-border').hide();
        }

    });
}





function updatePayTerm() {

    $.ajax({
        type: "PUT",
        url: '/st/erpSettingController/updatePayTerm/' + $('#txtPayTerm').attr('data-id'),
        data: {
            'value': $('#txtPayTerm').val()
        },
        headers: {
            'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
        },
        timeout: 800000,
        beforeSend: function () {
            $("#settingsAddModal").modal('hide');
        },
        success: function (response) {
            console.log(response);

            if (response.data.success) {

                showSuccessMessage("Pay Terms has been updated successfully...");
                getAllPayTerm();


            } else {
                showErrorMessage();
            }

        },
        error: function (error) {
            console.log(error);
            showErrorMessage();
        },
        complete: function () {

        }

    });
}




function updateCurrency() {

    $.ajax({
        type: "PUT",
        url: '/st/erpSettingController/updateCurrency/' + $('#txtCurrency').attr('data-id'),
        data: {
            'currency': $('#txtCurrency').val(),
            'iso': $('#txtISO').val(),
            'symbol': $('#txtSymbol').val(),
        },
        headers: {
            'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
        },
        timeout: 800000,
        beforeSend: function () {
            $("#settingsAddModal").modal('hide');
        },
        success: function (response) {
            console.log(response);

            if (response.data.success) {

                showSuccessMessage("Currency has been updated successfully...");
                getAllCurrency();


            } else {
                showErrorMessage();
            }

        },
        error: function (error) {
            console.log(error);
            showErrorMessage();
        },
        complete: function () {

        }

    });
}






function disablePayTerm(event, id) {


    var status = event.target.checked;
    var bool = 0;
    if (status) bool = 1;

    $.ajax({
        type: "PUT",
        url: '/st/erpSettingController/disablePayTerm/' + id,
        data: {
            'status': bool,
        },
        headers: {
            'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
        },
        timeout: 800000,
        beforeSend: function () {
            $("#settingsAddModal").modal('hide');
        },
        success: function (response) {
            console.log(response);

            if (response.data.success) {

                if (status) showSuccessMessage("Data has been enabled successfully...");
                if (!status) showSuccessMessage("Data has been disabled successfully...");
                getAllStores();


            } else {
                var msg = response.data.message;
                var id = response.data.result;

                if (msg == "assigned") {//assigned settings cannot be disabled
                    showWarningMessage("Settings has been assigned...!");
                    getAllStores();
                } else if (msg == "error") {
                    showErrorMessage();
                }
            }

        },
        error: function (error) {
            console.log(error);
            showErrorMessage();
        },
        complete: function () {

        }

    });
}




function disableCurrency(event, id) {


    var status = event.target.checked;
    var bool = 0;
    if (status) bool = 1;

    $.ajax({
        type: "PUT",
        url: '/st/erpSettingController/disableCurrency/' + id,
        data: {
            'status': bool,
        },
        headers: {
            'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
        },
        timeout: 800000,
        beforeSend: function () {
            $("#settingsAddModal").modal('hide');
        },
        success: function (response) {
            console.log(response);

            if (response.data.success) {

                if (status) showSuccessMessage("Data has been enabled successfully...");
                if (!status) showSuccessMessage("Data has been disabled successfully...");
                getAllStores();


            } else {
                var msg = response.data.message;
                var id = response.data.result;

                if (msg == "assigned") {//assigned settings cannot be disabled
                    showWarningMessage("Settings has been assigned...!");
                    getAllStores();
                } else if (msg == "error") {
                    showErrorMessage();
                }
            }

        },
        error: function (error) {
            console.log(error);
            showErrorMessage();
        },
        complete: function () {

        }

    });
}






/**
* generateID
* This function is used to generate id
* @param id This is the paramter to require id
*/
function generateID(id) {

    let pattern = {
        1: "0000",
        2: "000",
        3: "00",
        4: "0",
    };
    var length = Math.ceil(Math.log(id + 1) / Math.LN10);
    return pattern[length] + id;
}


/**
* showSuccessMessage
* This function is used to show success message.
* @param message This is the paramter to require message content
*/
function showSuccessMessage(message) {

    toastr.success(message);
}



/**
* showErrorMessage
* This function is used to show error message.
* @param message This is the paramter to require message content
*/
function showErrorMessage() {
    toastr.error('Something went wrong');
}


/**
* showWarrningMessage
* This function is used to show warning message.
* @param message This is the paramter to require message content
*/
function showWarningMessage(message) {

    toastr.warning(message);
}
