var contact_id = null;
$(document).ready(function () {
    resetSupplier();
    loadSettings();

    var supplier_id = getUrlParameter('id');
    var action = getUrlParameter('action');
    if (supplier_id != '' && action == 'edit' || action == 'view') {
        getSupplier(supplier_id);
        if (action == 'edit') {
            $('#btnAction').text('Update');
            $('#btnReset').show();
        }
        if (action == 'view') {
            $('#btnAction').hide();
            $('#btnReset').show();
        }
    }

    $('#btnAction').on('click', function (event) {

        $('#' + isRequiredInputsSave().tab).trigger('click');

        if ($(this).text() == 'Save') {
            if (isRequiredInputsSave().isRequired) {
                if (isDuplicateID($('#txtSupplierId').val()) == "true") {
                    showWarningMessage('Duplicate supplier id');
                    return;
                }
                save();
            }
        } else if ($(this).text() == 'Update') {
            if (isRequiredInputsUpdate().isRequired) {
                update(supplier_id);
            }
        }


    });


    $('#selcDistrict').on('change', function () {
        var id = $(this).val();
        loadTown(id);
    });


    $('#btnAddContact').on('click', function () {
        $('#txtSupplierEmail').val('');
        $('#txtSupplierDesignation').val('');
        $('#txtSupplierMobile').val('');
        $('#txtSupplierFixedMobile').val('');
        $('#checkPrimaryContact').prop('checked', false);
        $('#checkSMSalert').prop('checked', false);
        $('#checkEmailAlert').prop('checked', false);
        $('#contactModal').modal('toggle');
    });

    $('#btnAdd').on('click', function () {
        addContacts();
    });


    permissionCheck();

});



function getUrlParameter(name) {
    name = name.replace(/[\[]/, '\\[').replace(/[\]]/, '\\]');
    var regex = new RegExp('[\\?&]' + name + '=([^&#]*)');
    var results = regex.exec(location.search);
    return results === null ? '' : decodeURIComponent(results[1].replace(/\+/g, ' '));
};


function loadSettings() {
    $.ajax({
        type: "GET",
        url: "/st/supplier/settings",
        async: false,
        processData: false,
        contentType: false,
        async: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                var collection = response.data.result;
                appendSettings(collection);

            } else {
                showErrorMessage();
            }

        },
        error: function (error) {
            console.log(error);
            showErrorMessage();

        },
        complete: function () {

        }

    });
}



function loadTown(id) {
    $.ajax({
        type: "GET",
        url: "/st/supplier/town/" + id,
        async: true,
        processData: false,
        contentType: false,
        async: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                var collection = response.data.result;
                $('#selcTown').empty();
                appendSettings(collection);

            } else {
                showErrorMessage();
            }

        },
        error: function (error) {
            console.log(error);
            showErrorMessage();

        },
        complete: function () {

        }

    });
}

/**
* appendSettings
* This function is used append option to combobox.
* @param collection This is the paramter to combobox elements item
*/
function appendSettings(collection) {

    $.each(collection['country'], function (index, value) {
        $('#selcCountry').append('<option value="' + value['country_id'] + '">' + value['country_name'] + '</option>');
    });

    $.each(collection['district'], function (index, value) {
        $('#selcDistrict').append('<option value="' + value['district_id'] + '">' + value['district'] + '</option>');
    });

    $.each(collection['town'], function (index, value) {
        $('#selcTown').append('<option value="' + value['town_id'] + '">' + value['town'] + '</option>');
    });

    $.each(collection['bank'], function (index, value) {
        $('#selcBank').append('<option value="' + value['bank_id'] + '">' + value['bank_name'] + '</option>');
    });

    $.each(collection['bankBranch'], function (index, value) {
        $('#selcBankBranch').append('<option value="' + value['bank_branch_id'] + '">' + value['bank_branch_name'] + '</option>');
    });

    $.each(collection['types'], function (index, value) {
        $('#selcSupplierType').append('<option value="' + value['supplier_type_id'] + '">' + value['supplier_type'] + '</option>');
    });

    $.each(collection['gl_posting'], function (index, value) {
        $('#selcGlPosting').append('<option value="' + value['gl_post_id'] + '">' + value['gl_post'] + '</option>');
    });
}




function isDuplicateID(id) {

    var bool = false;
    $.ajax({
        type: "GET",
        url: "/st/supplier/isDuplicate/" + id,
        async: true,
        processData: false,
        contentType: false,
        async: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            bool = response;

        },
        error: function (error) {
            console.log(error);
            showErrorMessage();

        },
        complete: function () {

        }

    });

    return bool;
}



function save() {

    $.ajax({
        type: "POST",
        url: '/st/supplier/save',
        data: getFormData(),
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);

            if (response.data.success) {

                showSuccessMessage("Supplier has been saved successfully...");
                resetSupplier();


            } else {
                showErrorMessage();
            }

        },
        error: function (error) {
            console.log(error);
            showErrorMessage();
        },
        complete: function () {

        }

    });
}


function update(id) {
    var _token = $("input[name='_token']").val();
    $.ajax({
        type: 'PUT',
        url: '/st/supplier/update/' + id,
        data: getPutData(),
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                showSuccessMessage('Supplier has been updated successfully...');
                location.href = "/st/supplier_list";

            } else {
                showErrorMessage();
            }

        },
        error: function (error) {
            console.log(error);
            showErrorMessage();
        },
        complete: function () {

        }

    });
}



function getSupplier(id) {
    $('#btnAction').show();
    $.ajax({
        type: "GET",
        url: "/st/supplier/getSupplier/" + id,
        async: true,
        processData: false,
        contentType: false,
        async: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                setSupplier(response.data.result);
                permissionCheck();
            } else {
                showErrorMessage('Supplier not found...!');
            }

        },
        error: function (error) {
            console.log(error);
            showErrorMessage();

        },
        complete: function () {

        }

    });
}



function setSupplier(supplier) {
    console.log(supplier);

    var account_group_id = supplier.account_group_id;
    var address = supplier.address;
    var alert_credit_limit = supplier.alert_credit_limit;
    var alert_credit_period = supplier.alert_credit_period;
    var bank_branch_id = supplier.bank_branch_id;
    var bank_id = supplier.bank_id;
    var country_id = supplier.country_id;
    var district_id = supplier.district_id;
    var gmap = supplier.gmap;
    var hold_credit_limit = supplier.hold_credit_limit;
    var hold_credit_period = supplier.hold_credit_period;
    var notes = supplier.notes;
    var status_id = supplier.status_id;
    var supplier_id = supplier.supplier_id;
    var supplier_name = supplier.supplier_name;
    var supplier_type_id = supplier.supplier_type_id;
    var tax1_no = supplier.tax1_no;
    var tax2_no = supplier.tax2_no;
    var town_id = supplier.town_id;
    var web_address = supplier.web_address;
    var distance = supplier.distance;

    $('#txtSupplierId').val(supplier_id);
    $('#txtSupplierName').val(supplier_name);
    $('#txtSupplierAddress').val(address);
    $('#txtSupplierWebAddress').val(web_address);
    $('#txtSupplierGoogleMap').val(gmap);
    $('#txtSupplierNote').val(notes);
    $('#txtVat').val(tax1_no);
    $('#txtSvat').val(tax2_no);
    $('#txtAlertCreditLimit').val(alert_credit_limit);
    $('#txtAlertCreditPeriod').val(alert_credit_period);
    $('#txtHoldCreditLimit').val(hold_credit_limit);
    $('#txtHoldCreditPeriod').val(hold_credit_period);
    $('#txtDistance').val(distance);

    loadTown(district_id);

    if (country_id) {
        setSelectedOption("selcCountry", country_id);
    }
    if (district_id) {
        setSelectedOption("selcDistrict", district_id);
    }
    if (town_id) {
        setSelectedOption("selcTown", town_id);
    }
    if (supplier_type_id) {
        setSelectedOption("selcSupplierType", supplier_type_id);
    }
    if (account_group_id) {
        setSelectedOption("selcGlPosting", account_group_id);
    }
    if (bank_id) {
        setSelectedOption("selcBank", bank_id);
    }

    if (bank_branch_id) {
        setSelectedOption("selcBankBranch", bank_branch_id);
    }



    var contacts = supplier.contacts;


    for (i = 0; i < contacts.length; i++) {
        contact_id = contacts[i].contact_id; //global variable
        var designation = contacts[i].designation;
        var email = contacts[i].email;
        var fixed = contacts[i].fixed;
        var mobile = contacts[i].mobile;
        var primary_contact = contacts[i].primary_contact;
        var sms_alert = contacts[i].sms_alert;
        var email_alert = contacts[i].email_alert;


        var supplier_email = email;
        var supplier_designation = designation;
        var supplier_mobile = mobile;
        var supplier_fixed_mobile = fixed;


        var supplier_primary_contact = "";
        var supplier_sms_alert = "";
        var supplier_email_alert = "";

        if (primary_contact) {
            supplier_primary_contact = "checked";
        }

        if (sms_alert) {
            supplier_sms_alert = "checked";
        }

        if (email_alert) {
            supplier_email_alert = "checked";
        }

        var rowID = createRowID(5);
        var strRoeID = "'" + rowID + "'";
        var row = '<tr id= "' + rowID + '">';
        row += '<td>' + supplier_email + '</td>';
        row += '<td>' + supplier_designation + '</td>';
        row += '<td>' + supplier_fixed_mobile + '</td>';
        row += '<td>' + supplier_mobile + '</td>';
        row += '<td><input type="checkbox" id="' + rowID + 'supplier_sms_alert"  ' + supplier_sms_alert + '></td>';
        row += '<td><input type="checkbox" id="' + rowID + 'supplier_email_alert" ' + supplier_email_alert + '></td>';
        row += '<td><input type="checkbox" id="' + rowID + 'supplier_primary_contact"  ' + supplier_primary_contact + '></td>';
        row += '<td><button type="button" class="btn btn-success" onclick="editContactModal(' + strRoeID + ')" ><i class="fa fa-pencil-square-o" aria-hidden="true"></button></td>';
        row += '<td><button type="button" class="btn btn-danger" onclick="deleteRow(' + strRoeID + ')"><i class="fa fa-trash" aria-hidden="true"></i></button></td>';

        $('#tblContacts').append(row);


    }







}




function getFormData() {
    var _token = $("input[name='_token']").val();
    var supplier_id = $('#txtSupplierId').val();
    var supplier_name = $('#txtSupplierName').val();
    var supplier_address = $('#txtSupplierAddress').val();
    var supplier_web = $('#txtSupplierWebAddress').val();
    var supplier_country = $('#selcCountry').val();
    var supplier_district = $('#selcDistrict').val();
    var supplier_town = $('#selcTown').val();
    var supplier_map = $('#txtSupplierGoogleMap').val();
    var supplier_note = $('#txtSupplierNote').val();
    var supplier_type = $('#selcSupplierType').val();
    var supplier_gl_posting = $('#selcGlPosting').val();
    var supplier_bank = $('#selcBank').val();
    var supplier_bankbranch = $('#selcBankBranch').val();
    var supplier_vat = $('#txtVat').val();
    var supplier_svat = $('#txtSvat').val();
    var supplier_alert_credit_limit = $('#txtAlertCreditLimit').val();
    var supplier_alert_credit_period = $('#txtAlertCreditPeriod').val();
    var supplier_hold_credit_limit = $('#txtHoldCreditLimit').val();
    var supplier_hold_credit_period = $('#txtHoldCreditPeriod').val();
    var contacts = getContacts();
    var distance = $('#txtDistance').val();
    if (isNaN(parseFloat(distance))) {
        distance = 0;
    }



    var formData = new FormData();
    formData.append("_token", _token);
    formData.append("supplier_id", supplier_id);
    formData.append("supplier_name", supplier_name);
    formData.append("supplier_address", supplier_address);
    formData.append("supplier_web", supplier_web);
    formData.append("supplier_country", supplier_country);
    formData.append("supplier_district", supplier_district);
    formData.append("supplier_town", supplier_town);
    formData.append("supplier_map", supplier_map);
    formData.append("supplier_note", supplier_note);
    formData.append("supplier_type", supplier_type);
    formData.append("supplier_gl_posting", supplier_gl_posting);
    formData.append("supplier_bank", supplier_bank);
    formData.append("supplier_bankbranch", supplier_bankbranch);
    formData.append("supplier_vat", supplier_vat);
    formData.append("supplier_svat", supplier_svat);
    formData.append("supplier_alert_credit_limit", supplier_alert_credit_limit);
    formData.append("supplier_alert_credit_period", supplier_alert_credit_period);
    formData.append("supplier_hold_credit_limit", supplier_hold_credit_limit);
    formData.append("supplier_hold_credit_period", supplier_hold_credit_period);
    formData.append("contacts", JSON.stringify(contacts));
    formData.append('distance', distance);
    return formData;
}




function getPutData() {
    var _token = $("input[name='_token']").val();
    var supplier_id = $('#txtSupplierId').val();
    var supplier_name = $('#txtSupplierName').val();
    var supplier_address = $('#txtSupplierAddress').val();
    var supplier_web = $('#txtSupplierWebAddress').val();
    var supplier_country = $('#selcCountry').val();
    var supplier_district = $('#selcDistrict').val();
    var supplier_town = $('#selcTown').val();
    var supplier_map = $('#txtSupplierGoogleMap').val();
    var supplier_note = $('#txtSupplierNote').val();
    var supplier_type = $('#selcSupplierType').val();
    var supplier_gl_posting = $('#selcGlPosting').val();
    var supplier_bank = $('#selcBank').val();
    var supplier_bankbranch = $('#selcBankBranch').val();
    var supplier_vat = $('#txtVat').val();
    var supplier_svat = $('#txtSvat').val();
    var supplier_alert_credit_limit = $('#txtAlertCreditLimit').val();
    var supplier_alert_credit_period = $('#txtAlertCreditPeriod').val();
    var supplier_hold_credit_limit = $('#txtHoldCreditLimit').val();
    var supplier_hold_credit_period = $('#txtHoldCreditPeriod').val();
    var contacts = getContacts();
    var distance = $('#txtDistance').val();
    if (isNaN(parseFloat(distance))) {
        distance = 0;
    }



    var formData = {
        "_token": _token,
        "supplier_id": supplier_id,
        "supplier_name": supplier_name,
        "supplier_address": supplier_address,
        "supplier_web": supplier_web,
        "supplier_country": supplier_country,
        "supplier_district": supplier_district,
        "supplier_town": supplier_town,
        "supplier_map": supplier_map,
        "supplier_note": supplier_note,
        "supplier_type": supplier_type,
        "supplier_gl_posting": supplier_gl_posting,
        "supplier_bank": supplier_bank,
        "supplier_bankbranch": supplier_bankbranch,
        "supplier_vat": supplier_vat,
        "supplier_svat": supplier_svat,
        "supplier_alert_credit_limit": supplier_alert_credit_limit,
        "supplier_alert_credit_period": supplier_alert_credit_period,
        "supplier_hold_credit_limit": supplier_hold_credit_limit,
        "supplier_hold_credit_period": supplier_hold_credit_period,
        "contacts": JSON.stringify(contacts),
        "contact_id": contact_id,
        "distance": distance,

    };
    return formData;
}




function resetSupplier() {

    $('#pills-general-tab').trigger('click');
    $('#supplierForm').trigger("reset");
    $('#btnAction').text('Save');
    $('#btnAction').show();
    $('#btnReset').hide();
    $('#tblContacts').empty();
    resetInput();
}


function setSelectedOption(id, valueToSelect) {
    let element = document.getElementById(id);
    element.value = valueToSelect;
}



function isExistingValue(arg) {

    var table = document.getElementById('tblContact');

    var rowLength = table.rows.length;
    var bool = false;
    for (var i = 0; i < rowLength; i += 1) {
        var row = table.rows[i];
        var value = row.cells[0].id;
        if (arg == value) {
            bool = true;
            break;
        }
    }
    return bool;
}


function createRowID(length) {
    var rowID = '';
    var characters = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789';
    var charactersLength = characters.length;
    for (var i = 0; i < length; i++) {
        rowID += characters.charAt(Math.floor(Math.random() * charactersLength));
    }
    return rowID;
}

function deleteRow(id) {

    $('#' + id).remove();

}


function getContacts() {

    var data = [];
    var table = document.getElementById('tblContacts');
    for (var r = 0, n = table.rows.length; r < n; r++) {
        data.push({
            "email": table.rows[r].cells[0].innerHTML,
            "designation": table.rows[r].cells[1].innerHTML,
            "fixed_mobile": table.rows[r].cells[2].innerHTML,
            "mobile": table.rows[r].cells[3].innerHTML,
            "sms_alert": checkBoxVal(table.rows[r].cells[4].innerHTML),
            "email_alert": checkBoxVal(table.rows[r].cells[5].innerHTML),
            "primary_alert": checkBoxVal(table.rows[r].cells[6].innerHTML),
        });
    }
    return data;

}



function checkBoxVal(strTag) {
    var parser = new DOMParser();
    var doc = parser.parseFromString(strTag, 'text/html');
    return doc.body.firstChild.checked;
}



function addContacts() {
    var supplier_email = $('#txtSupplierEmail').val();
    var supplier_designation = $('#txtSupplierDesignation').val();
    var supplier_mobile = $('#txtSupplierMobile').val();
    var supplier_fixed_mobile = $('#txtSupplierFixedMobile').val();
    var supplier_primary_contact = $('#checkPrimaryContact').is(':checked');
    var supplier_sms_alert = $('#checkSMSalert').is(':checked');
    var supplier_email_alert = $('#checkEmailAlert').is(':checked');

    var supplier_primary_contact = "";
    var supplier_sms_alert = "";
    var supplier_email_alert = "";

    if ($('#checkPrimaryContact').is(':checked')) {
        supplier_primary_contact = "checked";
    }

    if ($('#checkSMSalert').is(':checked')) {
        supplier_sms_alert = "checked";
    }

    if ($('#checkEmailAlert').is(':checked')) {
        supplier_email_alert = "checked";
    }

    var rowID = createRowID(5);
    var strRoeID = "'" + rowID + "'";
    var row = '<tr id= "' + rowID + '">';
    row += '<td>' + supplier_email + '</td>';
    row += '<td>' + supplier_designation + '</td>';
    row += '<td>' + supplier_fixed_mobile + '</td>';
    row += '<td>' + supplier_mobile + '</td>';
    row += '<td><input type="checkbox" id="' + rowID + 'supplier_sms_alert"  ' + supplier_sms_alert + '></td>';
    row += '<td><input type="checkbox" id="' + rowID + 'supplier_email_alert" ' + supplier_email_alert + '></td>';
    row += '<td><input type="checkbox" id="' + rowID + 'supplier_primary_contact"  ' + supplier_primary_contact + '></td>';
    row += '<td><button type="button" class="btn btn-success" onclick="editContactModal(' + strRoeID + ')" ><i class="fa fa-pencil-square-o" aria-hidden="true"></button></td>';
    row += '<td><button type="button" class="btn btn-danger" onclick="deleteRow(' + strRoeID + ')"><i class="fa fa-trash" aria-hidden="true"></i></button></td>';

    $('#tblContacts').append(row);

}


function editContactModal(id) {

    $('.table tbody').on('click', '.btn', function (event) {


        var currow = $(this).closest('tr');
        var supplier_email = currow.find('td:eq(0)').text();
        var supplier_designation = currow.find('td:eq(1)').text();
        var supplier_fixed_mobile = currow.find('td:eq(2)').text();
        var supplier_mobile = currow.find('td:eq(3)').text();
        var supplier_primary_contact = $('#' + id + 'supplier_primary_contact').is(':checked');
        var supplier_sms_alert = $('#' + id + 'supplier_sms_alert').is(':checked');
        var supplier_email_alert = $('#' + id + 'supplier_email_alert').is(':checked');

        $('#txtSupplierEmail').val(supplier_email);
        $('#txtSupplierDesignation').val(supplier_designation);
        $('#txtSupplierMobile').val(supplier_mobile);
        $('#txtSupplierFixedMobile').val(supplier_fixed_mobile);
        $('#checkPrimaryContact').prop('checked', supplier_primary_contact);
        $('#checkSMSalert').prop('checked', supplier_sms_alert);
        $('#checkEmailAlert').prop('checked', supplier_email_alert);

    });

    $('#contactModal').modal('toggle');
    //deleteRow(id);
}


function permissionCheck() {
    if ($('#btnAction').text() == 'Save') {
        if (add_permission != 1) {
            $('#btnAction').hide();
        } else {
            $('#btnAction').show();
        }
    } else if ($('#btnAction').text() == 'Update') {
        if (edit_permission != 1) {
            $('#btnAction').hide();
        } else {
            $('#btnAction').show();
        }
    }
}


/**
* showSuccessMessage
* This function is used to show success message.
* @param message This is the paramter to require message content
*/
function showSuccessMessage(message) {
    toastr.success(message);
}


/**
* showWarningMessage
* This function is used to show warning message.
* @param message This is the paramter to require message content
*/
function showWarningMessage(message) {
    toastr.warning(message);
}



/**
* showErrorMessage
* This function is used to show error message.
* @param message This is the paramter to require message content
*/
function showErrorMessage() {
    toastr.error('Something went wrong');
}