@extends('st::layouts.app')

@section('head')
<!-- DataTable -->
<link rel="stylesheet" href="{{ url('vendors/dataTable/datatables.min.css') }}" type="text/css">
<!-- Prism -->
<link rel="stylesheet" href="{{ url('vendors/prism/prism.css') }}" type="text/css">
<link rel="stylesheet" href="{{ url('assets/css/hr/employeeList.css') }}" type="text/css">
<script>
    var edit_permission = "{{ Auth::user()->can('st_product_edit')}} ";
    var view_permission = "{{ Auth::user()->can('st_product_view')}} ";
    var delete_permission = "{{ Auth::user()->can('st_product_delete')}} ";
</script>

@endsection

@section('content')

<div class="row">
    <div class="col-md-12">
        <div class="card ">
            <div class="card-body">
                <h6 class="card-title">Product list</h6>
                {{ csrf_field() }}
                <table id="tblProduct" class="table table-striped table-bordered dataTable dtr-inline collapsed" role="grid" aria-describedby="example1_info">
                    <thead>
                        <tr>
                            <th>Product ID</th>
                            <th>Product Name</th>
                            <th>Group1  Name</th>
                            <th>Group2  Name</th>
                            <th>Edit</th>
                            <th>View</th>
                            <th>Delete</th>
                        </tr>
                    </thead>
                    <tbody id="tblProductList"></tbody>
                </table>
            </div>
        </div>
    </div>
</div>
@endsection

<!-- Javascript -->
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
@section('script')
<!-- DataTable -->
<script src="{{ url('vendors/dataTable/datatables.min.js') }}"></script>
<script src="{{ url('assets/js/examples/datatable.js') }}"></script>
<!-- <script src="{{ url('assets/js/hr/employeeList.js') }}"></script> -->

<!-- Prism -->
<script src="{{ url('vendors/prism/prism.js') }}"></script>

<!-- custom js  -->
<!-- <script src="{{ url('assets/js/sc/product_list.js') }}"></script> -->
<script src="{{ Module::asset('st:js/product_list.js') }}?random=<?php echo uniqid(); ?>"></script>
@endsection